#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
struct struc{
    int num,data;
};
bool cmp(struc s1, struc s2) {
    return s1.data<s2.data;
}
vector<struc> v;
vector<int> colors;
vector<vector<int>> g;
vector<bool> used;
void dfs(int i) {
    used[i]=true;
    for (auto &c:g[i]) {
        if (!used[c]) {
            colors[c]=3-colors[i];
            dfs(c);
        }
    }
}
int main() {
    int n,t;
    cin>>n;
    colors.resize(n); v.resize(n); g.resize(n); used.resize(n,false);
    vector<int> ans(n);
    for (int i=0;i<n;i++) {
        cin>>t;
        v[i]={i,t};
    }
    vector<int> numbers;
    sort(v.begin(),v.end(),cmp);
    for (long long i=1;i<n;i++) {
        long long j=2,tmp=v[i].data;
        while (j*j<=tmp) {
            if (tmp%j==0) {
                numbers.push_back(v[i].data/j);
            }
            while (tmp%j==0) {
                tmp=tmp/j;
            }
            j++;
        }
        if (tmp!=1) {
            numbers.push_back(v[i].data/tmp);
        }
        for (auto &c:numbers) {
            long long a = 0, b = i;
            while (a + 1 != b) {
                tmp=(a+b)/2;
                if (v[tmp].data>c) {
                    b=tmp;
                } else {
                    a=tmp;
                }
            }
            for (long long k=a;v[a].data==c && k>=0;k--) {
                g[i].push_back(a);
                g[a].push_back(i);
            }
        }
        numbers.clear();
    }
    for (int i=n-1;i>=0;i--) {
        if (!used[i]) {
            colors[i]=1;
            dfs(i);
        }
    }
    for (long long i=0;i<n;i++) {
        ans[v[i].num]=colors[i];
    }
    for (long long i=0;i<n;i++) {
        cout<<ans[i]<<' ';
    }
    return 0;
}
