#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
struct event {
    bool isready;
    int time;
};
bool cmp(event e1, event e2) {
    return e1.time<e2.time;
}
int main() {
    int n,m,t;
    cin>>n>>m;
    vector<event> events;
    for (int i=0;i<n;i++) {
        cin>>t;
        events.push_back({false,t});
    }
    for (int i=0;i<n;i++) {
        cin>>t;
        events.push_back({true,t+events[i].time});
    }
    sort(events.begin(),events.end(),cmp);
    int q=0, ready=0, gtime=0, cur=0;
    while (q<m && ready==0) {
        gtime=events[cur].time;
        for (int i=cur;events[i].time==gtime;i++) {
            if (events[i].isready) {
                ready+=2;
            }
            q++;
            cur++;
        }
    }
    while (q<m) {
        gtime++;
        q+=ready;
        ready*=2;
        for (int i=cur;events[i].time==gtime;i++) {
            if (events[i].isready) {
                ready+=2;
            }
            q++;
            cur++;
        }
    }
    if (q==m) {
        cout<<gtime;
    } else {
        cout<<-1;
    }
    return 0;
}
